
# bind scripts to label widget to allow editing
proc configureLabelWidget {w} {
	global MarkupGui
	
	set MarkupGui(b1_down) 0
	# identify label + prepare for dragging
	bind $w <ButtonPress-1> {
		set cursor_msec [%W pixtomsec %x]
		set MarkupGui(label_segment) [%W getnearest $cursor_msec]
		set MarkupGui(b1_down) 0
		set MarkupGui(dragging) 0
		set MarkupGui(ignore_release) 0
		if {$MarkupGui(label_segment) != "" && \
			abs([%W msectopix [lindex $MarkupGui(label_segment) 0]]-%x)<3} {
			set MarkupGui(b1_down) 1
		}
		focus %W
	}
	
	# drag
	bind $w <Motion> {
		#set MarkupGui(xy) [XYFormat %x %y %W]
		set cursor_msec [%W pixtomsec %x]
		if {$MarkupGui(b1_down)} {
		if {$MarkupGui(dragging) == 0 && \
					$MarkupGui(label_segment) != ""} {
					set MarkupGui(dragging) 1
					%W setactive [lindex $MarkupGui(label_segment) 0]
					}
			%W setbegin $cursor_msec
		} else {
			set segment [%W getnearest $cursor_msec]
			if {$segment != "" && \
				abs([%W msectopix [lindex $segment 0]] - %x) < 3} {
				%W cursor2
			} else {
				%W cursor1
			}
		}
	} 

  bind $w <ButtonRelease-1> {
		if {$MarkupGui(ignore_release)} {
				set MarkupGui(ignore_release) 0
		} else {
			set MarkupGui(b1_down) 0
			if {$MarkupGui(dragging) == 0} {
				set oldseg   [%W getactive]
				%W setactive [%W pixtomsec %x]
				set newseg   [%W getactive]
				if {$newseg == ""} {
					%W newsegment 0
				} else {
					set begin_t [lindex $newseg 0]
					set end_t   [lindex $newseg 1]
				}
			} else {
				set MarkupGui(dragging) 0
			}
		}
	}
		
	bind $w <KeyPress> {
		if {[%W getactive] == ""} {
			return 0
		}
		if {[IsLegalChar "%A"]} {
			%W append %A
		}
	}
	bind $w <BackSpace> {
		%W backspace
	}
	bind $w <Insert> {
		set seg [%W getactive]
		if {$seg == ""} {
			continue
		}
		%W newsegment [expr ([lindex $seg 0]+[lindex $seg 1])/2.0]
	}
	bind $w <Delete> {
    set curr_active [$w getactive]
    if {$curr_active == {}} {
      return 0
    }
    set old_time [lindex $curr_active 0]
    $w delete
    set near_seg [$w getnearest $old_time]
    $w setactive [lindex $near_seg 0]
	}
} 
			

#-----------------------------------------------------------------------
# IsLegalChar checks if the argument is a legal character for labeling

proc IsLegalChar {c} {
    if {$c == ""} {
        return 0
        }
    if {[regexp {^[]{} a-zA-Z0-9~`!@#$%^&*()_+=|\[,./?;:'"<>-]$} $c]} {
        return 1
        }
    return 0
    }
			
		
		
		