# 

source markupGui_main.tcl
source markupGui_xmlparse.tcl
global MarkupGui

# Convert from graphically marked up text to Sable source
proc updateSource {graphtext sabletext} {
	copyTextWidget $graphtext $sabletext
	graph2sable $sabletext
}

# send text string to Festival, then to audio
# should also include baldi
proc initTTS {} {
  mytts addWave-> myface <-Wave
  mytts addTranscription-> myface <-Transcription
  mytts addEvent-> myface <-Event
  myface addWave-> myaudio <-Wave
  myface addEvent-> myaudio <-Event
  myaudio addEvent-> myface <-SyncEvent
}

proc mkdoTTS { text  } {
  mytts <-Text $text
  # sync
  mytts <-Event done
  myaudio waitfor done
}

proc doTTS_old {text} {
  if 1 {
    global mytts myaudio
    set res [mytts tts "$text"]
    myaudio play [lindex $res 0]
    nuke $res
  } else {
    set fp [open d:/develop/markupGui/tmp.txt w]
    puts $fp $text
    close $fp
  }
}

package require TTS
#package require Festival 1.4.0	
package require Audio
package require Face
#TTS create mytts "mytts server" {type Festival desc "*1.4.0*"}
TTS create mytts "mytts server"
Audio create myaudio "myaudio server"
Face create myface "myface server"

# initialize MarkupGui
# if no images or sounds are available on system, comment out respective lines
initTTS 
initializeMarkupGui
markupSetTTSCommand mytts
set dir [file join $env(CSLU_PREFIX) apps tts-markup]
markupCreateImages $dir/emoticons $dir/gesticons $dir/speaker_icons
set dir [file join $env(CSLU_PREFIX) .. .. Festival 1.4.0 festival lib sounds]
markupFindSounds $dir

# initialize expat parser for going from sable to graphically marked up text
# init will require expat package
markupParseInit

# create text widgets for graphical input and for the sable source 
text .t -font {size 15} -height 8 -width 40 -wrap word
text .t2 -height 8 -height 14 -wrap word
pack .t .t2 -fill x

# some external controls.
set w ""
menu $w.mb  
$w.mb configure -borderwidth 1 -relief raised 
set m [menu $w.mb.file -tearoff 0 ]  
$w.mb add cascade -label File -menu $m -font lgfont 
$m add command -label "Show Console" -command "console show" 
$m add separator
$m add command -label Exit  -command "destroy ." 
. config -menu $w.mb  
button .b -width 12 -text "Update Source" -command "updateSource .t .t2"
button .b2 -width 12 -text "Speak" -command "playGraphtext .t"
button .b3 -width 14 -text "Back to Composer" -command \
  "cleanupAtts all; markupParse \[.t2 get 1.0 end\] .t"
checkbutton .b4 -width 12 -text "Enable Details" -variable MarkupGui(detailsEnabled) \
  -command "if \[winfo exists .t.markupGui\] { cancelPopup .t .t.markupGui; openPopup .t .t.markupGui}"

.t insert 1.0 "Cslu is the Center for Spoken Language Understanding, not the Center of Spoken Language Understanding."
#.t insert 1.0 "Cslu is the Center for Spoken Language Understanding, not of."
pack .b .b2 .b3 -side left -pady 3 -padx 5
pack .b4 -side right -pady 3 -padx 5

bind .t <Button-1> "fakeSelect %W destroy; tkTextButton1 %W %x %y; \
                    set tkPriv(selectMode) word; \
                    %W tag remove sel 0.0 end; break"
bind .t <ButtonRelease-3> {
	set w %W.markupGui
  if [winfo exists $w] { 
		cancelPopup .t $w 
	} 
	openPopup .t $w
}
bind .t <Destroy> {
	global MarkupGui ContourVars
  if [info exists MarkupGui] { unset MarkupGui }
  if [info exists ContourVars] { unset ContourVars }
}

console show
#set MarkupGui(detailsEnabled) 1